//    SpyWindows - A hierarchical Windows handle viewer
//    Copyright (C) 2006  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace SpyWindows
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.Button buttonRefresh;
		internal int columnToSort = 0;
		private System.Windows.Forms.TextBox textBoxProcessNameFilter;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.CheckBox checkBoxHexadecimal;
		private System.Windows.Forms.ColumnHeader columnHeaderCaption;
		private System.Windows.Forms.ColumnHeader columnHeaderClass;
		private System.Windows.Forms.ColumnHeader columnHeaderHandle;
		private System.Windows.Forms.ColumnHeader columnHeaderParentHandle;
		private System.Windows.Forms.ColumnHeader columnHeaderThread;
		private System.Windows.Forms.ColumnHeader columnHeaderProcess;
		private System.Windows.Forms.ColumnHeader columnHeaderProcessName;
		private System.Windows.Forms.ColumnHeader columnHeaderModuleName;
		private System.Windows.Forms.TreeListView treeListViewWindows;
		private System.Windows.Forms.ImageList imageListTreeListWindows;
		private System.Windows.Forms.TextBox textBoxModuleNameFilter;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button buttonExpandCollapse;
		private System.Windows.Forms.Button buttonAll;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.buttonRefresh = new System.Windows.Forms.Button();
			this.textBoxProcessNameFilter = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.checkBoxHexadecimal = new System.Windows.Forms.CheckBox();
			this.treeListViewWindows = new System.Windows.Forms.TreeListView();
			this.columnHeaderClass = new System.Windows.Forms.ColumnHeader();
			this.columnHeaderCaption = new System.Windows.Forms.ColumnHeader();
			this.columnHeaderHandle = new System.Windows.Forms.ColumnHeader();
			this.columnHeaderParentHandle = new System.Windows.Forms.ColumnHeader();
			this.columnHeaderThread = new System.Windows.Forms.ColumnHeader();
			this.columnHeaderProcess = new System.Windows.Forms.ColumnHeader();
			this.columnHeaderProcessName = new System.Windows.Forms.ColumnHeader();
			this.columnHeaderModuleName = new System.Windows.Forms.ColumnHeader();
			this.imageListTreeListWindows = new System.Windows.Forms.ImageList(this.components);
			this.textBoxModuleNameFilter = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.buttonExpandCollapse = new System.Windows.Forms.Button();
			this.buttonAll = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// buttonRefresh
			// 
			this.buttonRefresh.Location = new System.Drawing.Point(8, 16);
			this.buttonRefresh.Name = "buttonRefresh";
			this.buttonRefresh.TabIndex = 0;
			this.buttonRefresh.Text = "Refresh";
			this.buttonRefresh.Click += new System.EventHandler(this.buttonRefresh_Click);
			// 
			// textBoxProcessNameFilter
			// 
			this.textBoxProcessNameFilter.Location = new System.Drawing.Point(464, 16);
			this.textBoxProcessNameFilter.Name = "textBoxProcessNameFilter";
			this.textBoxProcessNameFilter.Size = new System.Drawing.Size(160, 20);
			this.textBoxProcessNameFilter.TabIndex = 5;
			this.textBoxProcessNameFilter.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(352, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(104, 20);
			this.label1.TabIndex = 4;
			this.label1.Text = "Process name filter";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// checkBoxHexadecimal
			// 
			this.checkBoxHexadecimal.Checked = true;
			this.checkBoxHexadecimal.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxHexadecimal.Location = new System.Drawing.Point(200, 16);
			this.checkBoxHexadecimal.Name = "checkBoxHexadecimal";
			this.checkBoxHexadecimal.Size = new System.Drawing.Size(96, 24);
			this.checkBoxHexadecimal.TabIndex = 2;
			this.checkBoxHexadecimal.Text = "Hexadecimal";
			// 
			// treeListViewWindows
			// 
			this.treeListViewWindows.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.treeListViewWindows.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																								  this.columnHeaderClass,
																								  this.columnHeaderCaption,
																								  this.columnHeaderHandle,
																								  this.columnHeaderParentHandle,
																								  this.columnHeaderThread,
																								  this.columnHeaderProcess,
																								  this.columnHeaderProcessName,
																								  this.columnHeaderModuleName});
			this.treeListViewWindows.ExpandMethod = System.Windows.Forms.TreeListViewExpandMethod.None;
			this.treeListViewWindows.GridLines = true;
			this.treeListViewWindows.Location = new System.Drawing.Point(8, 48);
			this.treeListViewWindows.Name = "treeListViewWindows";
			this.treeListViewWindows.Size = new System.Drawing.Size(944, 376);
			this.treeListViewWindows.SmallImageList = this.imageListTreeListWindows;
			this.treeListViewWindows.TabIndex = 8;
			this.treeListViewWindows.DoubleClick += new System.EventHandler(this.treeListViewWindows_DoubleClick);
			// 
			// columnHeaderClass
			// 
			this.columnHeaderClass.Text = "Class";
			this.columnHeaderClass.Width = 118;
			// 
			// columnHeaderCaption
			// 
			this.columnHeaderCaption.Text = "Caption";
			this.columnHeaderCaption.Width = 163;
			// 
			// columnHeaderHandle
			// 
			this.columnHeaderHandle.Text = "Handle";
			this.columnHeaderHandle.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.columnHeaderHandle.Width = 63;
			// 
			// columnHeaderParentHandle
			// 
			this.columnHeaderParentHandle.Text = "Parent Handle";
			this.columnHeaderParentHandle.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.columnHeaderParentHandle.Width = 80;
			// 
			// columnHeaderThread
			// 
			this.columnHeaderThread.Text = "Thread";
			this.columnHeaderThread.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// columnHeaderProcess
			// 
			this.columnHeaderProcess.Text = "Process";
			this.columnHeaderProcess.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// columnHeaderProcessName
			// 
			this.columnHeaderProcessName.Text = "Process Name";
			this.columnHeaderProcessName.Width = 188;
			// 
			// columnHeaderModuleName
			// 
			this.columnHeaderModuleName.Text = "Module Name";
			this.columnHeaderModuleName.Width = 225;
			// 
			// imageListTreeListWindows
			// 
			this.imageListTreeListWindows.ImageSize = new System.Drawing.Size(16, 16);
			this.imageListTreeListWindows.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageListTreeListWindows.ImageStream")));
			this.imageListTreeListWindows.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// textBoxModuleNameFilter
			// 
			this.textBoxModuleNameFilter.Location = new System.Drawing.Point(744, 16);
			this.textBoxModuleNameFilter.Name = "textBoxModuleNameFilter";
			this.textBoxModuleNameFilter.Size = new System.Drawing.Size(200, 20);
			this.textBoxModuleNameFilter.TabIndex = 7;
			this.textBoxModuleNameFilter.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(632, 16);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(104, 20);
			this.label2.TabIndex = 6;
			this.label2.Text = "Module name filter";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// buttonExpandCollapse
			// 
			this.buttonExpandCollapse.Location = new System.Drawing.Point(88, 16);
			this.buttonExpandCollapse.Name = "buttonExpandCollapse";
			this.buttonExpandCollapse.Size = new System.Drawing.Size(104, 23);
			this.buttonExpandCollapse.TabIndex = 1;
			this.buttonExpandCollapse.Text = "Expand/Collapse";
			this.buttonExpandCollapse.Click += new System.EventHandler(this.buttonExpandCollapse_Click);
			// 
			// buttonAll
			// 
			this.buttonAll.Location = new System.Drawing.Point(304, 16);
			this.buttonAll.Name = "buttonAll";
			this.buttonAll.Size = new System.Drawing.Size(32, 23);
			this.buttonAll.TabIndex = 3;
			this.buttonAll.Text = "All";
			this.buttonAll.Click += new System.EventHandler(this.buttonAll_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(960, 430);
			this.Controls.Add(this.buttonAll);
			this.Controls.Add(this.buttonExpandCollapse);
			this.Controls.Add(this.textBoxModuleNameFilter);
			this.Controls.Add(this.treeListViewWindows);
			this.Controls.Add(this.checkBoxHexadecimal);
			this.Controls.Add(this.textBoxProcessNameFilter);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.buttonRefresh);
			this.Controls.Add(this.label2);
			this.Name = "Form1";
			this.Text = "Spy Windows";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		/*
		 * GetWindow() Constants
		 */
		public const uint GW_HWNDFIRST = 0;
		public const uint GW_HWNDLAST = 1;
		public const uint GW_HWNDNEXT = 2;
		public const uint GW_HWNDPREV = 3;
		public const uint GW_OWNER = 4;
		public const uint GW_CHILD = 5;
		public const uint GW_ENABLEDPOPUP = 6;
		public const uint GW_MAX = 6;

		[DllImport("user32.dll")]
		public extern static IntPtr GetWindow(IntPtr hWnd, uint uCmd);
		[DllImport("user32.dll", SetLastError=true)]
		public static extern int EnumChildWindows(IntPtr hWndParent, EnumChildWindowsProc callback, IntPtr lParam);
		public delegate int EnumChildWindowsProc(IntPtr hWnd, IntPtr lParam);
		[DllImport("user32.Dll")]
		public static extern int EnumWindows(EnumWindowsProc callback, IntPtr lparam);
		public delegate int EnumWindowsProc(IntPtr hWnd, IntPtr lParam);
		[DllImport("User32.Dll")]
		public static extern int GetWindowText(IntPtr hWnd, StringBuilder s, int nMaxCount);
		[DllImport("User32.Dll")]
		public static extern int GetClassName(IntPtr hWnd, StringBuilder s, int nMaxCount);
		[DllImport("User32.Dll")]
		public static extern IntPtr PostMessage(IntPtr hWnd, int msg, int wParam, int lParam);
		[DllImport("user32.dll")]
		public static extern bool ShowWindowAsync(IntPtr hWnd, int nCmdShow);
		[DllImport("user32.dll")]
		public static extern bool SetForegroundWindow(IntPtr hWnd);
		[DllImport("user32.dll")]
		public static extern bool IsIconic(IntPtr hWnd);
		[DllImport("user32.dll")]
		public static extern bool IsZoomed(IntPtr hWnd);
		[DllImport("user32.dll")]
		public static extern bool IsGUIThread(bool bConvert);
		[DllImport("user32.dll")]
		public static extern IntPtr GetForegroundWindow();
		[DllImport("user32.dll", CharSet=CharSet.Auto)]
		public static extern UInt32 GetWindowThreadProcessId(IntPtr hWnd, out UInt32 lpdwProcessId);
		[DllImport("user32.dll")]
		public static extern IntPtr AttachThreadInput(IntPtr idAttach, IntPtr idAttachTo, int fAttach);
		[DllImport("user32.dll")]
		private static extern int GetWindowModuleFileName(IntPtr hWnd, StringBuilder title, int size);
		[DllImport("user32.dll")]
		public static extern IntPtr GetParent(IntPtr hWnd);

		public const uint GA_PARENT = 1;
		public const uint GA_ROOT = 2;
		public const uint GA_ROOTOWNER = 3;

		[DllImport("user32.dll")]
		public static extern IntPtr GetAncestor(IntPtr hWnd, uint gaFlags);
		
		[StructLayout(LayoutKind.Sequential)]
			public struct RECT
		{
			public Int32 left;
			public Int32 top;
			public Int32 right;
			public Int32 bottom;
		}

		[StructLayout(LayoutKind.Sequential)]
			public struct WINDOWINFO
		{
			public UInt32 cbSize;
			public RECT rcWindow;
			public RECT rcClient;
			public UInt32 dwStyle;
			public UInt32 dwExStyle;
			public UInt32 dwWindowStatus;
			public UInt32 cxWindowBorders;
			public UInt32 cyWindowBorders;
			public UInt16 atomWindowType;
			public UInt16 wCreatorVersion;
		}

		[DllImport("user32.dll", SetLastError = true)]
		public static extern int GetWindowInfo(IntPtr hwnd, out WINDOWINFO pwi);

		//		[DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
		//		public static extern IntPtr FindWindow([MarshalAs(UnmanagedType.LPTStr)] string lpClassName, [MarshalAs(UnmanagedType.LPTStr)] string lpWindowName);

		[DllImport("psapi.dll")]
		public static extern int GetModuleFileNameExA(IntPtr hProcess, IntPtr hModule, StringBuilder lpFilename, uint nMaxCount);
		
		public const uint PROCESS_TERMINATE = 0x0001;
		public const uint PROCESS_CREATE_THREAD = 0x0002;
		public const uint PROCESS_SET_SESSIONID = 0x0004;
		public const uint PROCESS_VM_OPERATION = 0x0008;
		public const uint PROCESS_VM_READ = 0x0010;
		public const uint PROCESS_VM_WRITE = 0x0020;
		public const uint PROCESS_CREATE_PROCESS = 0x0080;
		public const uint PROCESS_SET_QUOTA = 0x0100;
		public const uint PROCESS_SET_INFORMATION = 0x0200;
		public const uint PROCESS_QUERY_INFORMATION = 0x0400;
		public const uint PROCESS_SUSPEND_RESUME = 0x0800;
		public const uint PROCESS_QUERY_LIMITED_INFORMATION = 0x1000;
		//public const uint PROCESS_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED | SYNCHRONIZE | 0xFFFF);

		[DllImport("kernel32.dll")]
		public static extern IntPtr OpenProcess(UInt32 dwDesiredAccess, Int32 bInheritHandle, UInt32 dwProcessId);
		[DllImport("kernel32.dll")]
		public static extern Int32 CloseHandle(IntPtr hObject);
		[DllImport("kernel32.dll")]
		public static extern Int32 ReadProcessMemory(IntPtr hProcess, IntPtr lpBaseAddress,[In, Out] byte[] buffer, UInt32 size, out IntPtr lpNumberOfBytesRead);
		[DllImport("kernel32.dll")]
		public static extern uint GetLastError();

		private void Clear()
		{
			treeListViewWindows.Items.Clear();
			windowInfoByHandle.Clear();
			listViewItemByHandle.Clear();
		}

		private void buttonRefresh_Click(object sender, System.EventArgs e)
		{
			Clear();

			try
			{
				EnumWindows(new EnumWindowsProc(this.MyEnumWindowsProc), IntPtr.Zero);
			}
			catch(Exception ex)
			{
				System.Diagnostics.Debug.WriteLine("Child Window failure: " + ex.Message);
			}
		}

		public class WindowInfo
		{
			public IntPtr handle;
			public IntPtr hParent;
			public string caption;
			public string className;
			public uint threadId;
			public uint processId;
			public string processName;
			public string moduleName;
		}

		public int MyEnumWindowsProc(IntPtr hWnd, IntPtr lParam)
		{
			if(hWnd != IntPtr.Zero)
			{
				PopulateWindow(hWnd, true);
				try
				{
					EnumChildWindows(hWnd, new EnumChildWindowsProc(this.MyEnumChildWindowsProc), IntPtr.Zero);
				}
				catch(Exception e)
				{
					System.Diagnostics.Debug.WriteLine("Child Window failure: " + e.Message);
				}
			}
			return 1;
		}

		public int MyEnumChildWindowsProc(IntPtr hWnd, IntPtr lParam)
		{
			if(hWnd != IntPtr.Zero)
			{
				PopulateWindow(hWnd, false);
			}
			return 1;
		}

		public Hashtable windowInfoByHandle = new Hashtable();
		public Hashtable listViewItemByHandle = new Hashtable();

		public WindowInfo PopulateWindow(IntPtr hWnd, bool topMost)
		{
			WindowInfo wi = (WindowInfo)windowInfoByHandle[hWnd];
			if(wi == null)
				windowInfoByHandle[hWnd] = wi = new WindowInfo();
			
			try
			{
				wi.handle = hWnd;
				wi.hParent = GetAncestor(hWnd, GA_PARENT);
				//wi.hParent = GetParent(hWnd);

				StringBuilder caption = new StringBuilder(1024);
				if(GetWindowText(hWnd, caption, 1024) != 0)
					wi.caption = caption.ToString();

				StringBuilder className = new StringBuilder(1024);
				if(GetClassName(hWnd, className, 1024) != 0)
					wi.className = className.ToString();

				uint processId = 0;
				wi.threadId = GetWindowThreadProcessId(hWnd, out processId);
				wi.processId = processId;

				IntPtr hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, 0, wi.processId);
				if(hProcess != IntPtr.Zero)
				{
					StringBuilder processName = new StringBuilder(1024);
					if(GetModuleFileNameExA(hProcess, IntPtr.Zero, processName, 1024) != 0)
						wi.processName = processName.ToString();
					CloseHandle(hProcess);
				}

				StringBuilder moduleName = new StringBuilder(1024);
				if(GetWindowModuleFileName(hWnd, moduleName, 1024) != 0)
					wi.moduleName = moduleName.ToString();
				else
					wi.moduleName = "???";

				//WINDOWINFO windowInfo;
				//if(GetWindowInfo(hWnd, out windowInfo) != 0)
				//{
				//}

				if(wi.moduleName.ToLower().IndexOf(textBoxModuleNameFilter.Text.ToLower()) != -1 &&
					wi.processName.ToLower().IndexOf(textBoxProcessNameFilter.Text.ToLower()) != -1)
				{
					string formatDecimal = (checkBoxHexadecimal.Checked ? "X" : "d");

					TreeListViewItem lvi = (TreeListViewItem)listViewItemByHandle[hWnd];
					if(lvi == null)
					{
						listViewItemByHandle[hWnd] = lvi = new TreeListViewItem(wi.className, 0);
						lvi.SubItems.Add(wi.caption);
						lvi.SubItems.Add(((uint)wi.handle).ToString(formatDecimal));
						lvi.SubItems.Add(((uint)wi.hParent).ToString(formatDecimal));
						lvi.SubItems.Add(wi.threadId.ToString(formatDecimal));
						lvi.SubItems.Add(wi.processId.ToString(formatDecimal));
						lvi.SubItems.Add(wi.processName.ToString());
						lvi.SubItems.Add(wi.moduleName.ToString());
						lvi.Tag = wi;
						lvi.Expand();
						bool mustAddItem = true;
						if(!topMost)
						{
							if(wi.hParent != IntPtr.Zero)
							{
								TreeListViewItem lviParent = (TreeListViewItem)listViewItemByHandle[wi.hParent];
								if(lviParent != null)
								{
									lviParent.Items.Add(lvi);
									mustAddItem = false;
								}
							}
						}

						if(mustAddItem)
							treeListViewWindows.Items.Add(lvi);
					}
					else
					{
						lvi.Text = wi.className;
						lvi.SubItems[1].Text = wi.caption;
						lvi.SubItems[2].Text = ((uint)wi.handle).ToString(formatDecimal);
						lvi.SubItems[3].Text = ((uint)wi.hParent).ToString(formatDecimal);
						lvi.SubItems[4].Text = wi.threadId.ToString(formatDecimal);
						lvi.SubItems[5].Text = wi.processId.ToString(formatDecimal);
						lvi.SubItems[6].Text = wi.processName.ToString();
						lvi.SubItems[7].Text = wi.moduleName.ToString();
					}
				}
			}
			catch(Exception ex)
			{
				System.Diagnostics.Trace.WriteLine(ex.ToString());
			}

			return wi;
		}

		bool collapse = true;
		private void buttonExpandCollapse_Click(object sender, System.EventArgs e)
		{
			if(collapse)
				treeListViewWindows.CollapseAll();
			else
				treeListViewWindows.ExpandAll();

			collapse = !collapse;
		}

		private void buttonAll_Click(object sender, System.EventArgs e)
		{
			textBoxModuleNameFilter.Text = textBoxProcessNameFilter.Text = "";
			buttonRefresh_Click(null, null);
		}

		private void treeListViewWindows_DoubleClick(object sender, System.EventArgs e)
		{
			if(treeListViewWindows.SelectedItems.Count > 0)
			{
				TreeListViewItem lvi = treeListViewWindows.SelectedItems[0];
				if(lvi != null)
				{
					WindowInfo wi = (WindowInfo)lvi.Tag;
					if(wi != null)
					{
						WindowInfoForm dlg = new WindowInfoForm();

						string formatDecimal = (checkBoxHexadecimal.Checked ? "X" : "d");

						string info = "className: " + wi.className + "\r\n";
						info += "caption: " + wi.caption + "\r\n";
						info += "handle: " + ((uint)wi.handle).ToString(formatDecimal) + "\r\n";
						info += "hParent: " + ((uint)wi.hParent).ToString(formatDecimal) + "\r\n";
						info += "threadId: " + wi.threadId.ToString(formatDecimal) + "\r\n";
						info += "processId: " + wi.processId.ToString(formatDecimal) + "\r\n";
						info += "processName: " + wi.processName + "\r\n";
						info += "moduleName: " + wi.moduleName + "\r\n";

						dlg.textBoxInfo.Text = info;
						dlg.ShowDialog(this);
					}
				}
			}
		}
	}
}
